{$A+,B-,I-,R-,S-,V-,X+}

program
 PCX_Viewer; {** (C) Marat V. Bilialov, New Systems Inc. **}

uses
 Dos, Crt;

const
 MaxBufLen = 65520;

type
 RGB = record
  Red,
  Green,
  Blue : Byte;
 end;

 PCXHeader = record
  Maker        : Byte;
  Version      : Byte;
  Code         : Byte;
  BitsPerPixel : Byte;
  XLow         : Word;
  YLow         : Word;
  XHigh        : Word;
  YHigh        : Word;
  Hres         : Word;
  Vres         : Word;
  Palette      : array [0..15] of RGB;
  VMode        : Byte;
  PlaneCount   : Byte;
  BytesPerLine : Word;
  Reserved     : array [0..59] of byte;
 end;

 BufType = array [1..MaxBufLen] of Byte;
 PtrToByte = ^Byte;

 Pallette = array [0..255] of RGB;

var
 PCXFile  : File;
 FileName : PathStr;
 Header   : PCXHeader;
 VGAPtr   : PtrToByte;
 Count    : Byte;
 Data     : Byte;
 i        : Byte;
 Regs     : Registers;
 PlaneNum : Byte;
 Bytes    : Word;
 Lines    : Word;
 Buf      : ^BufType;
 BufPtr   : Word;
 BufLen   : Word;
 Pal      : Pallette;
 VGAFile  : Boolean;

Function RGBColor(ColorNum : Byte) : Byte;
 begin
  RGBColor := (((Header.Palette[ColorNum].Red div 85) and 1) shl 5) +
              (((Header.Palette[ColorNum].Red div 85) and 2) shl 1) +
              (((Header.Palette[ColorNum].Green div 85) and 1) shl 4) +
              (((Header.Palette[ColorNum].Green div 85) and 2) shl 0)+
              (((Header.Palette[ColorNum].Blue div 85) and 1) shl 3)+
              (((Header.Palette[ColorNum].Blue div 85) and 2) shr 1);
 end;

BEGIN
 FileName := ParamStr(1);
 Write('File name : ');
 if FileName = '' then
  ReadLn(FileName)
 else
  WriteLn(FileName);

 Assign(PCXFile, ParamStr(1));
 Reset(PCXFile, 1);
 BlockRead(PCXFile, Header, SizeOf(PCXHeader));

 VGAFile := Header.BitsPerPixel = 8;        { ᫨ 8 ,  256 梥⮢.  }
                                            {  ᨮ,  p⠥.    }
 if VGAFile then
  begin
   Seek(PCXFile, FileSize(PCXFile)-SizeOf(Pal)); {  256-梥⭮ 䠩    }
   BlockRead(PCXFile, Pal, SizeOf(pal));         { p  ᠬ . }
   Seek(PCXFile, SizeOf(header));
  end;

 New(Buf);
 BufLen := 0;
 BufPtr := 1;
 Lines  := 0;


 if VGAFile then
  asm                                        { 筮 p     }
   lea si, pal                               { ᪠ p楤p p㧪 }
   mov cx, 768                               { VGA譮 p.           }
  @1:
   shr byte ptr [si], 1
   shr byte ptr [si], 1
   inc si
   loop @1

   mov ax, 0013h                             { 320x200x256colors          }
   int 10h

   mov ax, 1012h
   xor bx, bx
   mov cx, 256
   mov dx, seg pal
   mov es, dx
   mov dx, offset pal
   int 10h                                   {  p - p⮬.      }
  end
 else
  begin                                      {   EG ⠪  ᤥ.   }
   Regs.AX:=$0010;
   Intr($10, Regs);

   for i := 0 to 15 do
    begin
     Regs.AH := $10;
     Regs.AL := 0;
     Regs.BL := i;
     Regs.BH := RGBColor(i);
     Intr($10, Regs);
    end;

   { Write mode }
   Port[$3CE] := 5;                          {  p⮢  .    }
   Port[$3CF] := 0;

   Bytes := 1;
   PlaneNum := 1;
   Port[$3C4] := 2;                          {  #1.                   }
   Port[$3C5] := 0;
  end;

 VGAPtr := Ptr($A000, $0000);

 repeat
  if BufPtr > BufLen then
   begin
    BlockRead(PCXFile, Buf^, MaxBufLen, BufLen);
    BufPtr := 1;
   end;

  Data := Buf^[BufPtr];
  Inc(BufPtr);

  if Data and $C0 = $C0 then                 { ᯠ RLE-pᨨ. }
   begin
    Count := Data and $3F;
    if BufPtr > BufLen then
     BlockRead(PCXFile, Data, 1)
    else
     begin
      Data := Buf^[BufPtr];
      Inc(BufPtr);
     end;
   end
  else
   Count := 1;

  for i := 1 to Count do
   begin
    PtrToByte(Longint(VGAPtr) + Bytes - 1)^ := Data;
    Inc(Bytes);
    if Bytes > Header.BytesPerLine then
     begin
      Bytes := 1;
      if VGAFile then
       begin
        Inc(Longint(VGAPtr), Header.BytesPerLine); { VGA => p 㢥- }
        Inc(Lines);                                {  稪.        }
       end
      else
       begin                                       { EGA => p   }
        if PlaneNum > 3 then                       {   0  3,    }
         begin                                     { ⮬ - 稪.     }
          PlaneNum := 0;
          Inc(Longint(VGAPtr), Header.BytesPerLine);
          Inc(Lines);
         end;
        Inc(PlaneNum);
        Port[$3C4] := 2;                           { ⢥ 롮p     }
        Port[$3C5] := 1 shl (PlaneNum-1);          { .               }
       end;
     end;
   end;
 until Lines > Header.YHigh;                       { , .         }

 ReadKey;

 Dispose(Buf);
 Close(PCXFile);

 TextMode(3);
END.
